


class MyProp:

  def __init__(self, getter):
    self.__getter = getter

  def __get__(self, obj, cls):
    print('GET IT!!!')
    return self.__getter(obj)


class MyDec:
  def __init__(self, *args):
    print(f'MyDec[  {args}  ]')

  def __call__(*args):
    print(f'MyDec.call[  {args}  ]')


class MyDesc:

  def __get__(self, obj, cls):
    return None

  def __set__(self, obj, value):
    pass

  def __delete__(self, obj):
    pass


class C:
  xy = MyDesc()

  @MyProp
  def wq(self):
    print('wq')
    return 'foo'
  
  y = 3
  def x(self):
    print(f'y: {__class__.y}')



c = C()


class Decorated:
  @MyDec
  def x(self): print('x')

  @MyDec(1, 2, 3)
  def y(self): print('y')

d = Decorated()


#d.x()
#d.y()



